# Fortress Builds
## Fortress 0.4

### 2020/09/16 Fortress 0.4.34 beta

* [Boolector](https://boolector.github.io/) solver is supported;
* CVC4 1.8 solver is used;
* Bug fixes and code improvements. 

### 2019/07/22 Fortress 0.4.33 beta

* New `SmtKeyword` class for SMT-LIBv2 keywords;
* Print user data for unsupported operation;
* `SmtTextSolver`: always parse model for array values;
* Other bug fixes and code improvements.

### 2018/08/20 Fortress 0.4.32 beta

* Enhancements in type calculation logic;
* New method `DataType.isTypeId`;
* New methods `Data.getString` and `NodeValue.getString`;
* Methods `Data.newArray` and `NodeValue.newArray` were renamed to `newMap`;
* Other bug fixes and code improvements.

### 2018/05/04 Fortress 0.4.31 beta

* New standard operation `FUNCTION`;
* Support for new operations in `VerilogExprPrinter` and `VhdlExprPrinter`;
* Support for IO streams in `XmlConstraintLoader` and `XmlConstraintSaver`;
* New utility method `Node.deepestCopy` to preserve user data;
* New convenience method `NodeValue.newBitVector(boolean)`;
* New `BitVectorMath` methods: `nandr`, `norr` and `xnorr`;
* Removed redundant size checks for multiplication and division 
  from `BitVectorMath`;
* Bug fix in `BitVector.valueOf(byte[], int)`;
* Other bug fixes and code improvements.

### 2018/02/19 Fortress 0.4.30 beta

* New utility methods `ExprUtils.isOperation`, `Node.isType`,
  and `CollectionUtils.mergeLists`;
* New method `Transformer.substitute(Node, NodeProvider)` that facilitates
  node substitution.

### 2018/02/02 Fortress 0.4.29 beta

* Pretty printing of SMT code;
* Improvements in the Java printer;
* New convenience methods for `NodeValue.newBitVector`;
* Additional `NodeVariable` constructor that takes a dynamic data object.

### 2018/01/22 Fortress 0.4.28 beta

* Utility class `Nodes` that provides shortcuts for constructing operation nodes;
* Printer for saving expressions into Java code;
* Code conventions enforced, which caused some renaming in public methods.

### 2017/08/17 Fortress 0.4.27 beta

* Bug fixes and improvements in `BitVector` (mappings reviewed).

### 2017/08/17 Fortress 0.4.26 beta
 
* Fix in `BitVectorMapping`;
* Improvement in type calculation rules (support unbounded `BVCONCAT`).

### 2017/05/22 Fortress 0.4.25 beta

* Transformer: transform `MAP` to `BIT_VECTOR`;
* Solver: `bv2int` (`bv2nat` for CVC4) and `int2bv` operations;
* Solver: solver-specific headers for generated *.smt2 files.

### 2017/05/11 Fortress 0.4.24 beta

* Improvements in `Randomizer` and `VariateInterval`;
* `Pair` can store `null`;

### 2017/03/24 Fortress 0.4.23 beta

* `SmtTextBuilder` was made public;
* `ConstraintUtils.newConstraint` for collections was implemented.

### 2017/03/16 Fortress 0.4.22 beta

* New `Randomizer` method: `permute`;
* Several bug fixes and code improvements.

### 2016/10/25 Fortress 0.4.21 beta

* Facilities to cast values in constant expressions;
* Improvements in `ESExprParser`.

### 2016/08/26 Fortress 0.4.20 beta

* New `NodeVariable` methods: `newInteger`, `newReal`, `newString`, `newBoolean`,
 `newUnknown`, `newBitVector` and `newMap`;
* New `ExprUtils` method: `isOperation` that takes multiple operation identifiers.

### 2016/05/27 Fortress 0.4.19 beta

* New interface `TreeVisitor` for visitors of hierarchical structures;
* `ExprTreeVisitor` methods `onRootBegin` and `onRootEnd` are renamed to
  `onBegin` and `onEnd`;
* New `BitVector` method: `repeat`;
* New `ExprUtils` methods: `isOperation`, `isValue`, `isVariable`;
* Several bug fixes and code improvements.

### 2016/02/05 Fortress 0.4.18 beta

* Several bug fixes were made.

### 2016/01/22 Fortress 0.4.17 beta

* New type `DataTypeId.LOGIC_STRING` for representing strings was added.

### 2015/12/25 Fortress 0.4.16 beta

* `Transformer.reduce` convenience method was implemented;
* `NodeOperation` takes a data type as a constructor argument to prevent dynamic
  type calculation.

### 2015/12/11 Fortress 0.4.15 beta

* New utility class `TypeConversion` providing methods for coercing
  expressions of integral types (`BV`, `Int`, `Bool`) has been implemented.

### 2015/11/27 Fortress 0.4.14 beta

* New method `BitVector.extend` was implemented.

### 2015/11/06 Fortress 0.4.13 beta

* Reusability improvements in `MapBasedPrinter`;
* New `Value<T>` utility interface for storing mutable values.

### 2015/10/30 Fortress 0.4.12 beta

* Usability improvements in `Transformer`;
* Some general improvements.

### 2015/10/23 Fortress 0.4.11 beta

* New `Data` methods: `equalTypes` and `equalValues`;
* Bugs in `Transformer` were fixed.

### 2015/09/04 Fortress 0.4.10 beta

* New `BitVector` methods: `setAll`, `isAllSet` and `isAllReset`.

### 2015/08/21 Fortress 0.4.9 beta

* Methods `getBigIntegerMask`, `getField` and `setField` were added in `BitUtils`;
* Method `nextBigIntegerField` was added in `Randomizer`;
* Methods `maskInt` and `maskLong` of `BitUtils` were renamed to
  `getIntegerMask` and `getLongMask` respectively.

### 2015/08/14 Fortress 0.4.8 beta

* Operations right shift (`StandardOperation.BVASHR`) and
  left shift (`StandardOperation.BVLSHL`) for `LOGIC_INTEGER` type
  are now supported in calculator.

### 2015/08/07 Fortress 0.4.7 beta

* Method `BitVector.resize` that supports zero extension and sign extension
  was implemented;
* More flexible expression printing facilities are available: visitor used
  in map-based expression printer can be overridden;
* Some general code improvements were made.

### 2015/07/30 Fortress 0.4.6 beta

* `InvariantChecks` methods with the message parameter were implemented;
* Some bug fixes and general code improvements were made.

### 2015/07/24 Fortress 0.4.5 beta

* Convenience methods `BitVector.field` and `ExprUtils.isKind` were implemented;
* Some bug fixes and general code improvements were made.

### 2015/07/17 Fortress 0.4.4 beta

* Support for the `POWER` operation in calculator (for integers);
* Some general improvements.

### 2015/06/26 Fortress 0.4.3 beta

* Utility general-purpose class `Result` was implemented;
* Utility method `newInteger` for `BigInteger` was added to `NodeValue`;
* Some general code improvements were made.

### 2015/06/11 Fortress 0.4.2 beta

* Type calculation rules for the `BVZEROEXT`, `BVSIGNEXT`, `SELECT` and `STORE`
  operators were implemented;
* The `BitVector` class was improved.

### 2015/05/20 Fortress 0.4.1 beta

* A couple of new utility methods were added.
* Some general code improvements were made.

### 2015/04/21 Fortress 0.4.0 beta

* Support for `CVC4` was implemented;
* Support for bit vectors, arrays and real numbers in calculator
  were implemented;
* Additional rules for expression transformer were implemented;
* Some bug fixes and general code improvements were made.

## Fortress 0.3
### 2015/03/20 Fortress 0.3.6 beta

* Some bug fixes and code improvements were made.

### 2015/03/05 Fortress 0.3.5 beta

* Classes for representing and building random variates were implemented.

### 2015/02/14 Fortress 0.3.4 beta

* Convenience methods simplifying access to expression value and type
  information were implemented;
* The expression transformer facility was enhanced;
* The possibility to control the order of visiting operands of
  an expression was implemented.

### 2014/12/26 Fortress 0.3.3 beta

* Methods for converting `BitVector` from and to `BigInteger`;
* Class `NodeBinding` that provides support SMT-LIB `let` constructs;
* Basic support for managing symbolic S-expressions;
* Support for arbitrary size integers (`LOGIC_INTEGER` is based on `BigInteger`);
* Textual representation of a constraint is included in error log when
  solver fails;
* Utility method `ExprUtils.isSAT` for checking satisfiability of expressions;
* Utility method `ExprUtils.getVariables` for getting the list of variables
  contained in an expression;
* Utility class `CollectionUtils` that facilitates manipulating collections;
* Class `ConstraintUtils` that provides methods to simplify creating and
  solving constraints;
* Improvement in solver implementation that allows interpreting boolean
  operands of bit vector operators as bit vectors of length 1;
* Debug and silent modes for SMT solvers (in the silent mode *.smt files
  are not saved in file system after a constant has been solved);
* Support for the `BVEXTRACT` operator in expression type calculation logic;
* Class `DataMap` for representing data of the `MAP` type;
* New rules for expression transformation in the predefined rule set.

### 2014/09/15 Fortress 0.3.2 beta

* Factory methods to simplify creating `NodeValue` objects;
* Support for creating deep copies of expressions;
* Utility classes for generating random values;
* Support for a variable number of operands in the expression calculator;
* Saving/loading constraints to/from an XML string;
* Aborting visiting an expression tree and skipping subtrees;
* Basic facilities to calculate the type of an expression;
* Extending the functionality of a solver with function templates;
* New standard operations: `ABS`, `MIN`, `MAX`, `BVANDR`, `BVNANDR`,
  `BVORR`, `BVNORR`, `BVXORR`, `BVXNORR`;
* Class `NodeExpr` was renamed to `NodeOperation`;
* XML format was simplified: nodes `Expression` and `Operation` were merged
  together (the new node is called `Operation`);
* Class `ExprUtils` that provides a set of useful methods to work with
  logical expressions;
* Expression printers for Verilog and VHDL hardware description languages;
* Support for the boolean type in the calculator.

### 2014/07/08 Fortress 0.3.1 beta

* Support for parametric operations with two or more parameters;
* Support for array operations;
* Support for the `BVEXTRACT` operation.

### 2014/01/13 Fortress 0.3.0 beta

* The library was redesigned and renamed to Fortress;
* The library was decomposed into a set of reusable packages
  (including data, expression, calculator, transform, solver);
* New classes for describing data were implemented
  (including a new bit vector implementation);
* A lot of refactoring has been done;
* A number of bugs was fixed.

## Java Constraint Solver API 0.2
### 2013/07/11 Java Constraint Solver API 0.2.2 beta

* Support for constant folding has been added;
* Support for user-defined calculators has been added;
* Several bugs have been fixed.

### 2013/06/11 Java Constraint Solver API 0.2.1 beta

* Support for parametric operations has been added;
* Support for ternary operations has been added;
* Support for user-defined objects and operations in constraint tree
  has been added;
* Several bugs have been fixed.

## Java Constraint Solver API 0.1
### 2013/04/11 Java Constraint Solver API 0.1 beta

* Constraints creating (in the form of abstract syntax trees);
* Constraints mapping to the SMT-LIB description (in this version
  only binary operations are supported);
* Constraints storing in external memory (as XML files);
* Z3 solver launching and transferring results back to Java.
