# Fortress

 Fortress (FORmula TRanslation, Evaluation and Symbolic Simplification), former
 JCSA (`Java Constraint Solver API`), is an open-source and extendible Java
 library providing facilities for manipulation with formulae (terms and
 constraints). The library allows creating formulae (in the form of syntax
 trees), translating them into external formats (programming languages, XML,
 SMT-LIB, etc.), evaluating them and doing symbolic simplification. It also
 supports constraint solving using built-in solvers as well as external ones
 (like Yices, Z3, CVC4, etc.)

## Project structure

 In the Fortress project, production code and unit tests are separated and
 located in the following folders respectively: `src/main/java`, `src/test/java`

 The package structure of unit tests replicates the package structure of
 production code. I.e. unit tests are located in the same packages as the classes
 they are intended to test.

## Preparing the project

 To check out the project from the Git repository, execute
 the following command:

 `git clone --recursive https://forge.ispras.ru/git/solver-api.git`

## Building the project

 1. To build the JAR file, execute the following command:

    `gradlew assemble`

 2. To run unit tests, execute the following command:

    `gradlew test`

## Building the project on the server side:

The the project can be built on the build server using the Jenkins
continuous integration tool. To do this, visit the following link:

 `https://forge.ispras.ru/jenkins/job/Fortress/`
